#if !defined(LIST_H)
#define LIST_H TRUE
/* ========================================================================
 * Name - list.h
 *
 * Description - interface to list.c
 *
 * $Id: list.h,v 1.3 1992/09/16 22:33:33 penneyj Exp $
 *
 * $Log: list.h,v $
 * Revision 1.3  1992/09/16  22:33:33  penneyj
 * misc cleanups
 *
 * Revision 1.2  1992/09/15  22:37:16  penneyj
 * misc facelift, preparing for distribution on alt.sources
 *
 * Revision 1.1  1992/09/15  22:18:47  penneyj
 * Initial revision
 *
 *========================================================================
 */

typedef struct _node {
  struct _node *next;
  char *key;		/* name of file, typically */
  char *dirname;	/* directory in which file was found */
  char *catname;	/* file in which to format results, if applicable */
  manPageEType kind;
  } NodeSType;

typedef NodeSType **ListType;

#define STREQUAL(a,b) (strcmp(a,b) == 0)
#define ADDTOLIST(a,i) add3list(a,i,NULL,NULL, NO_PAGE)

#define KILLTHIS(item) {\
  (*item)->key = (*item)->catname = (*item)->dirname = NULL; \
  (*item)->kind = NO_PAGE; }

/* This last macro is very convenient for this type lists, */
/* but it assumes you use it in the right way.  In */
/* particular 'item' will have to be locally defined and type list. */

#define LIST_DO(thelist) \
  for (item = (thelist); *item != NULL; item= &(*item)->next)

/*
 *  Global lists.
 *  keywords taken from command line.
 *  showfiles holds arguments for the pager.
 *  searchdirs is list of real directories that ought to be searched.
 *  matchingFiles holds files that should be processed and added to showfiles.
 */
ListType keywords, showfiles, sections, searchdirs;
ListType searchtrees, tmpfiles, matchingFiles;

#if defined(FLG_PROTOTYPE)
ListType newlist(void);
#else
ListType newlist();
#endif

#if defined(FLG_PROTOTYPE)
ListType addnull(ListType argl);
#else
ListType addnull();
#endif

#if defined(FLG_PROTOTYPE)
int inlist23(ListType argl, const char *item2, const char *item3);
#else
int inlist23();
#endif

#if defined(FLG_PROTOTYPE)
void add3list(ListType argl, const char *item1, const char *item2,
    const char *item3, manPageEType kind);
#else
void add3list();
#endif

#if defined(FLG_PROTOTYPE)
void push3list(ListType argl, const char *item1,
    const char *item2, const char *item3);
#else
void push3list();
#endif

#if defined(FLG_PROTOTYPE)
void cleannulls(ListType argl);
#else
void cleannulls();
#endif

#if defined(FLG_PROTOTYPE)
void printlist(ListType argl);
#else
void printlist();
#endif

#if defined(FLG_PROTOTYPE)
int noofitems(ListType argl);
#else
int noofitems();
#endif

ListType sections; /* Global variable declared in main.c, */
		      /* but used in functions insect and */
		      /* insect2. */

#endif /* LIST_H */
